//TODO: put these functions in myftp.c and myftpserve.c
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
// #include <netdb.h>
#include <string.h>
#include <unistd.h>
// #include <sys/wait.h>
// #include <time.h>
#include "myftp.h"


void setUpSocket(int* socketFD, struct sockaddr_in* servAddr){
    if((*socketFD = socket(AF_INET, SOCK_STREAM, 0)) == -1){
    	// fprintf(stderr, "Error Sh1\n");
        error(strerror(errno), 1, "Sh1");
    }

    if(setsockopt(*socketFD, SOL_SOCKET, SO_REUSEADDR, &(int){1}, sizeof(int))){
    	// fprintf(stderr, "Error Sh2\n");
        error(strerror(errno), 1, "Sh2");
    }
    
    memset(servAddr, 0, sizeof(*servAddr));
    servAddr->sin_family = AF_INET;
    servAddr->sin_port = htons(PORT);
    servAddr->sin_addr.s_addr = htons(INADDR_ANY);
}


void sendString(int FD, char* string, int len){
	int count = 0, ret; 
	fprintf(stderr, "Start write\n");
	while(count < len){
		if((ret = write(FD, string+count, len-count)) == -1){
			// fprintf(stderr, "Error Sh3\n");
			error(strerror(errno), 1, "Sh3");
		}
		count += ret;
	}
	fprintf(stderr, "Wrote -%s-\n", string);
}


void error(const char* message, int exitVal, char* debug){
	if(DEBUG) fprintf(stderr, "Error %s\n");
    fprintf(stdout, "Error: %s\n", message);
    exit(exitVal);
}