#include <stdio.h>
// #include <stdlib.h>
#include <errno.h>
// #include <netdb.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>
// #include <time.h>
#include <ctype.h>
#include "myftp.h"

// #define ADDR "localhost"
//TODO: Remove Comments and extraneous fprintf statements
//TODO: Add comment about getting server/client code from my assignment 8 submission
//TODO: 


void notImplemented(char* command){
	printf("%s not implemented\n", command);
}


void getCommand(char* command, char** argument){
	printf("Enter Command:\n>");
	fgets(command, CMDLEN, stdin); //TODO: do I need to use read()?
	for(int i = 0; i < CMDLEN; i++){
		if(!isspace(command[i])) continue;
		command[i] = '\0';
		if(*argument == NULL) *argument = command+i+1;
	}
	fprintf(stderr, "You entered: -----%s-----\nArgument: -----%s-----\n", command, *argument);
}


void lsCMD(){
	if(fork() != 0) return;
	execlp("ls", "ls", "-l", NULL);
	// fprintf(stderr, "Error Cl3\n");
	error(strerror(errno), 1, "Cl3"); 
}


void cdCMD(char* argument){
	if(chdir(argument) == -1){
		fprintf(stderr, "Error Cl4\n");
		error(strerror(errno), 1, "Cl4");
		//TODO: Handle certain errors without exiting
	}
	printf("Directory changed to: %s\n", argument);
}


// void sendString(int FD, char* string){
// 	int len = strlen(string);
// 	int count = 0, ret; 
// 	fprintf(stderr, "Start write\n");
// 	while(count < len){
// 		if((ret = write(FD, string+count, len-count)) == -1){
// 			fprintf(stderr, "Error Cl5\n");
// 			error(strerror(errno), 1);
// 		}
// 		count += ret;
// 	}
// 	fprintf(stderr, "Wrote -%s-\n", string);
// }


void sendCommand(int socketFD, char* command, char* argument){
	sendString(socketFD, command, strlen(command));
	sendString(socketFD, argument, strlen(argument));
}


int main(int argc, char* argv[]){
	//Check args
	if(argc != 2) error("Invalid number of arguments", 1, "Cl5");

	printf("Client\n");

	//Set Up Server
	int socketFD = connectToServer(argv[1]);
    
	while(1){
	//Get command from user
		char command[CMDLEN];
		char* argument = NULL;
		getCommand(command, &argument);

		//Run Command
		if(strcmp("exit", command) == 0){
			sendCommand(socketFD, command, argument);
			notImplemented(command);
		} else if(strcmp("cd", command) == 0) cdCMD(argument);
		else if(strcmp("rcd", command) == 0){
			notImplemented(command);
		} else if(strcmp("ls", command) == 0) lsCMD();
		else if(strcmp("rls", command) == 0){
			notImplemented(command);
		} else if(strcmp("get", command) == 0){
			notImplemented(command);
		} else if(strcmp("show", command) == 0){
			notImplemented(command);
		} else if(strcmp("put", command) == 0){
			notImplemented(command);
		} else if(strcmp("help", command) == 0){
			notImplemented(command);
		} else {
			fprintf(stderr, "Invalid Command: %s\n", command);
		}
		wait(NULL);
	}

    close(socketFD);

	return 0;
}


//TODO: test connecting to IP address
int connectToServer(char* addr){
	int socketFD;
    struct sockaddr_in servAddr;
    setUpSocket(&socketFD, &servAddr);

    struct addrinfo hints;
    memset(&hints, 0, sizeof(hints));
    struct addrinfo* actualdata;
    int err;

    hints.ai_socktype = SOCK_STREAM;
    hints.ai_family = AF_INET;
    err = getaddrinfo(addr, PORTSTR, &hints, &actualdata);
    if(err != 0){
    	// fprintf(stderr, "Error Cl1\n");
    	error(gai_strerror(err), 1, "Cl1");
    }

    if(connect(socketFD, (struct sockaddr*)&servAddr, sizeof(servAddr)) == -1){
    	// fprintf(stderr, "Error Cl2\n");
        error(strerror(errno), 1, "Cl2");   
    }

    fprintf(stderr, "Client Connected\n");
    return socketFD;
}