// #include <stdio.h>
// #include <stdlib.h>
// #include <errno.h>
#include <netdb.h>
// #include <string.h>
// #include <unistd.h>
// #include <sys/wait.h>
// #include <time.h>

#ifndef MYFTP_H
#define MYFTP_H

#define PORT 49999
#define PORTSTR "49999"
#define CMDLEN 128 //TODO: Max path length + longest command length?
#define DEBUG 1
#define FILEIO 1024

//Shared functions
//TODO: put these functions in myftp.c and myftpserve.c
void setUpSocket(int* socketFD, struct sockaddr_in* servAddr);
void error(const char* message, int exitVal, char* debug);

void sendString(int FD, char* string, int len);



//Server Functions
void setUpServer(int* listenFD);
pid_t serverFork(int listenFD, int* connectFD);
void receiveCommand(int FD, char* string);
int CCMD(char* argument, int connectFD);
int DCMD(int* dataFD, int connectFD);
int LCMD(int* dataFD, int connectFD);
int GCMD(char* argument, int* dataFD, int connectFD);
int PCMD(char* argument, int* dataFD, int connectFD);



//Client Functions
int connectToServer(char* addr);



#endif